#include "model_handler.h"
#include "sensor_cli.h"
#include <zephyr/logging/log.h>
#include <bluetooth/mesh/models.h>


////////////////////////////////////////
// Initialization functions
////////////////////////////////////////
static void attention_on(struct bt_mesh_model *mod)
{
    //TODO: Implement blink function
    //serverInitialized = false;
}

static void attention_off(struct bt_mesh_model *mod)
{
    //TODO: Disable blink function
    //serverInitialized = true;
}

static const struct bt_mesh_health_srv_cb health_srv_cb = {
	.attn_on = attention_on,
	.attn_off = attention_off,
};

static struct bt_mesh_health_srv health_srv = {
    .cb = &health_srv_cb,
};

BT_MESH_HEALTH_PUB_DEFINE(health_pub, 0);


////////////////////////////////////////
// Tranciever Implementation functions
////////////////////////////////////////


struct tranciever_handlers tHandlers = {
    .tx_data = send_message,
    .rx_data = recieve_message
};


static struct tranciever_client tranciever = {
    .handlers = &tHandlers,
};


void send_message(uint16_t addr, uint8_t *msg)
{
	int err = tranciever_message_send(&tranciever, addr, msg);
	if (err) {
		//LOG_WRN("Failed to publish message: %d", err);
	}
}


void recieve_message(struct tranciever_client *chat, struct bt_mesh_msg_ctx *ctx)
{

}


const struct bt_mesh_elem elements[] = {

    BT_MESH_ELEM (
                    1,
                    BT_MESH_MODEL_LIST( 
                        BT_MESH_MODEL_CFG_SRV,
                        BT_MESH_MODEL_HEALTH_SRV(&health_srv, &health_pub)),
                    BT_MESH_MODEL_LIST(BT_MESH_RX_TX_MODEL(&tranciever))),

}; 


static const struct bt_mesh_comp comp = {
    .cid = COMPANY_ID,
    .elem = elements,
    .elem_count = ARRAY_SIZE(elements),
};

const struct bt_mesh_comp *model_handler_init(void)
{
	return &comp;
}

